'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIII  BASIC++DEMO ZUM BASIC-COMPUTER UNIT MICRO    (by DIE HARD IIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'--------------------------------------------------------------------
' Beispiel zum BASIC-COMPUTER  mit dem Programmer/Application-Board
'--------------------------------------------------------------------
' ANWENDUNG:   ZUBEHR IR SENDE/EMPFANGSMODUL 198860 oder TSOP1836
'              IR-COMMUNICATIONS DRIVER
'--------------------------------------------------------------------
' Dieses Beispiel zeigt die Vorgehensweise fr die Benutzung des IR
' Treibers (RC5 codiert) im Betriebssystem, zusammen mit
' dem als Zubehr erhltlichen SENDE/EMPFANGSMODUL oder mit einem
' IR Empfngerbaustein TSOP 1838
' Das IR SENDE/EMPFANGSMODUL 198860 knnen Sie verwenden wenn sie
' Die MICRO mit einem MICRO-MODUL am Applicationboard 2.0 betreiben.
' Dazu muss der PORT4 der UNIT mit PORT2 auf der BUSLEISTE des Application
' Boards verbunden sein.
' Ausserdem ist zur Anzeige ein IIC-BUS LCD erfoderlich, wenn sie kein
' MICRO-MODUL verwenden.
' Das MICRO-MODUL ermglicht es das LCD am Applicationboard zur Anzeige zu
' verwenden. Der erforderliche Portbaustein PCF8574 befindet sich auf
' diesem Modul.
'--------------------------------------------------------------------
' Das RC5 Format wird von den meisten Gerten der Unterhaltungsindustrie
' verwendetund ermglicht es Ihnen diese Gerte mit dem BASIC-Computer
' zu steuern. Das RC5 Format besteht aus einer Gerteadresse und einem
' Kommando. Das IR-MODULE erwartet zwei PUT Anweisungen (jeweils
' die Adresse, danach das Kommando)und sendet dann den entsprechenden
' Datenrahmen. Empfangene Daten werden mit jeweils zwei GET Anweisungen
' abgerufen
'
' RC5 FORMAT:
'    13-12-11-10-09-08-07-06-05-04-03-02-01-00   DATA BIT
'     S  S  T a4 a3 a2 a1 a0 c5 c4 c3 c2 c1 c0   RC5
'
' Das IR-Module erwartet an Port 2 den Ausgang eines IR-Empfngers
' (z.B. TSOP 4836) und an Port 3 eine IR-LED als Datensender.
' Der Teiber untersttzt den IR Datensender allerdings nicht, sodass
' nur Empfang mglich ist.

' Beschreibung:
' Das Programm wartet auf einen empfangenen IR-Code.
' Wird ein Code empfangen, so wird der Empfangene Code am LCD angezeigt.
' Es wurde nichts empfangen, oder der Empfangsbuffer ist bereits geleert,
' wenn der Inhalt von ADDR und CMD jeweils 0 ist.
'-----------------------------------------------------------------------
' SIE DRFEN DIESEN TREIBER NUR LADEN, WENN DIE PAGE0/1 NICHT VON ANDEREN
' TREIBERN/SYSTEMERWEITERUNGEN, DIE SIE BENTIGEN, BELEGT IST !
' Der Treiber ist nicht fr die MICRO mit der OS-Version 2.00 geeignet
'---------------------------------------------------------------------

'-------------------------------------------------------------------
'Hier sehen Sie, welche PCF 8574 Ports dem LCD zugeordnet sind:
'Port 0  LCD DB4
'Port 1  LCD DB5
'Port 2  LCD DB6
'Port 3  LCD DB7
'Port 4  LCD R/W
'Port 5  LCD RS
'Port 6  LCD EN
'-------------------------------------------------------------------

'--------------------------
'------ I/O PORTS ---------
'--------------------------
'--- IIC INTERFACE  -------
define SDA      port[2]
define SCL      port[5]
'---- IR RECCEIER ---------
define IRIN      port[4]
define COMMAND   byte[1]
define ADDRESS   byte[2]
define DATABYTE as byte
define ZEHNER      as byte
define EINER       as byte
'--------------------------
'------ SYSTEM MEMORY -----
'--------------------------

const ADDR=01001110b' LCD ADRESSE


import "....\LIB\ASCII_TABLE.BAS"
import "....\LIB\MICRO_IIC_GENERIC.BAS"
import "....\LIB\MICRO_IIC_PCF8574_IO.BAS"
import "....\LIB\MICRO_IIC_LCD_DRIVE.BAS"

'----------------------------------------------------
'          SPLIT VALUE INTO DIGITS
'----------------------------------------------------
FUNCTION SPLIT_DIGITS()
ZEHNER=DATABYTE/10
EINER=DATABYTE-ZEHNER*10+30h
ZEHNER=ZEHNER+30h 
END FUNCTION

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'II   PCF 8574 PORTERWEITERUNG FR LCD        II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'---------- IICBUS INIT ------------------------
SDA=on
SCL=on
'------------   LCD INIT -----------------------
pause 2
LCD_INIT(ADDR)
'--------- IR BACKGROUND RECEIVING INIT --------
SYS FD06h 
ADDRESS=0
COMMAND=0
'------- WRITE CHARACTERS LINE 1 ---------------
LINE1(ADDR,1)
LCD_WRITE(ADDR,20h,W)
LCD_WRITE(ADDR,20h,A)
LCD_WRITE(ADDR,20h,I)
LCD_WRITE(ADDR,20h,T)
LCD_WRITE(ADDR,20h,I)
LCD_WRITE(ADDR,20h,N)
LCD_WRITE(ADDR,20h,G)
LCD_WRITE(ADDR,20h,DOT)
LCD_WRITE(ADDR,20h,DOT)
LCD_WRITE(ADDR,20h,DOT)

#LOOP
if (ADDRESS or COMMAND)=0 then goto LOOP
LINE1(ADDR,1)
LCD_WRITE(ADDR,20h,A)
LCD_WRITE(ADDR,20h,D)
LCD_WRITE(ADDR,20h,R)
LCD_WRITE(ADDR,20h,BLANK)
DATABYTE=ADDRESS
SPLIT_DIGITS()
LCD_WRITE(ADDR,20h,ZEHNER)
LCD_WRITE(ADDR,20h,EINER)

LINE2(ADDR,1)
LCD_WRITE(ADDR,20h,C)
LCD_WRITE(ADDR,20h,M)
LCD_WRITE(ADDR,20h,D)
LCD_WRITE(ADDR,20h,BLANK)
DATABYTE=COMMAND
SPLIT_DIGITS()
LCD_WRITE(ADDR,20h,ZEHNER)
LCD_WRITE(ADDR,20h,EINER)
ADDRESS=0
COMMAND=0
pause 10
LCD_CLR(ADDR)

goto LOOP
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII

SYSCODE "RC5_P0.s19"






attributes
ccproject                 
ccproject                
            
          
          
         
       
      
     
    
      
  
 
end attributes
